// © 2022, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

// Include this file only once when compiling:
#pragma once

// Include the dynamic array called "vector"
#include <vector>

// Include matrix and vector:
#include <glm/glm.hpp>

// Include a struct for storing uv coordinates:
#include "TexCoord.h"

/**
 * Represents a Vertex with different types of information.
 */
struct Vertex {
    /** Stores the position (X,Y,Z,1) of this vertex */
    glm::vec3 position = glm::vec3(0,0,0);

    /** Stores the normal (X,Y,Z,0) of this vertex */
    glm::vec3 normal = glm::vec3(0,0,0);

    /** Initializes the attributes with the given parameter values */
    Vertex(glm::vec3 position = glm::vec3(0,0,0), glm::vec3 normal = glm::vec3(0,0,0))
        : position(position)
        , normal(normal)
    {}


    std::vector<Vertex*> neighbours;
};
